//+------------------------------------------------------------------+
//|                                                      ProjectName |
//|                                      Copyright 2020, CompanyName |
//|                                       http://www.companyname.net |
//+------------------------------------------------------------------+
#include  <Trade\Trade.mqh>
CTrade trade;
//---
input double   lotSize           = 0.1;
input int      StopLoss          = 150;
input int      TakeProfit        = 100;
input string   StartTradingTime  = "02:00";
input string   StopTradingTime   = "05:00";
//---
string CurrentTime;
bool TradingIsAllowed=false;
double Resistance=99999;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnTick()
  {
//--- initialize time
   datetime time=TimeTradeServer();
   CurrentTime=TimeToString(time,TIME_MINUTES);
//--- initialize Close & Open
   double close[];
   ArraySetAsSeries(close,true);
   CopyClose(_Symbol,_Period,0,3,close);
   double open[];
   ArraySetAsSeries(open,true);
   CopyOpen(_Symbol,_Period,0,3,open);
//--- detect resistance
   if(close[1]<close[2] && open[1]>open[2])
     {
      Resistance=close[2];
     }
//--- trade
   if(CheckTradingTime()==true)
      if((close[1] > Resistance) && (OrdersTotal()==0))//Breakout with no pending order open
        {
         trade.SellStop(lotSize,Resistance,_Symbol,Resistance+StopLoss*_Point,Resistance-TakeProfit*_Point,ORDER_TIME_GTC,0,NULL);
        }
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool CheckTradingTime()
  {
   string curr_time=StringSubstr(CurrentTime,0,5);
   if(StringSubstr(CurrentTime,0,5)==StartTradingTime)
      TradingIsAllowed=true;
   if(StringSubstr(CurrentTime,0,5)==StopTradingTime)
      TradingIsAllowed=false;
   Comment(StartTradingTime,"-",StopTradingTime," curr: ",curr_time," -> ",TradingIsAllowed,", OrdersTotal(): ",OrdersTotal());
//---
   return(TradingIsAllowed);
  }
//+------------------------------------------------------------------+
